#include "inland_config.h"
! ---------------------------------------------------------------------
subroutine arr2vec(array, vect)
! extracts land points from array and puts them into a land-only vector
      use inland_ibispar
      use inland_combcs, only: lmask
#ifdef COUPLED
      use inland_intermap
#endif /* COUPLED */

      implicit none
!------------------------------Arguments--------------------------------
! Input arguments
      real*8, intent(in)  :: array(plona,plata)
      real*8, intent(out) :: vect(lbeg:lend)

#ifdef COUPLED
      real*8 arlocal(plona,beglata:endlata)

      call scatvar(array,arlocal,plona)
      call ccm_to_ibis(arlocal,vect,plona,beglata,endlata,1)

#else /* COUPLED */
! Local variables
      integer npts,i,j
      
      npts=0
      do 10 j= 1,plata
         do 20 i= 1,plona
            if (lmask(i,j) .eq. 1) then
               npts = npts + 1
               vect(npts) = array(i,j)
            endif
20       continue
10    continue

      if (npts .ne. npoi/mlpt) then
         write (*,*) '*** ERROR: arr2vec: number of land points in lmask '// &
                     'does not match number of land points specified in '// &
                     'input parameters file.'
         stop 1
      endif
#endif /* COUPLED */
      return
end subroutine arr2vec
