#include "inland_config.h"
module inland_comwork
      use inland_ibispar
      implicit none
      public
      save

! -------
! comwork
! -------
!
! this file holds work space arrays and the longitude
! and latitude vectors.  The value of ndim3 should be nlon*nlat times
! the largest 3rd dimension in compar (max of nband,nsoilay,nsnolay,npft).
!   Ndim3 is now being defined on ibisalloc, so actual calculation of
! max(nband,nsoilay,nsnolay,npft) is done.

!    The variable ndim4 is calculated on main_offline subroutine. For the 
! offline model, the needed information is provided as compile-time macros on
! ibisparm module. For now, this is how it works, but dimensions should be 
! allowed to change without the need of recompiling the code.
!    For that matter, ndim4 will be calculated on main_offline in order to fa-
! cilitate calculating it once values are provided by the inland.infile curren-
! tly read on main_offline subroutine.
      integer ndim2, ndim3, ndim4
      real*8 ocean

      parameter ( ocean=9.e+20 ) ! the value to use for non-land points
      parameter ( ndim2 = nlon*nlat)

      character aname*21       ! use to store short names

! lonindex(npoi): i index of nth point in land+sea array (i,j)
! latindex(npoi): j index of nth point in land+sea array (i,j)
      integer, allocatable :: lonindex(:), latindex(:)     

! lonscale(nlon): longitude of nth point in degrees east [nlon]
! latscale(nlat): latitude of nth point in degrees north [nlat]
! cdummy(ndim3): work space big enough for npft grids [ndim3]
! work(ndim2): work space big enough for one full grid [ndim2]
      real*8, dimension(:), allocatable :: lonscale(:), latscale(:), work(:)
      real*8, dimension(:), allocatable, target :: cdummy(:)
end module inland_comwork
