#include "inland_config.h"
!TODO: header, make allocation subroutines inside each corresponding module
! ---------------------------------------------------------------------
subroutine ibisalloc
!-----------------------------------------------------------------------
!     Allocate variables
!---------------------------Code history--------------------------------
!     Original version: A.A. Mirin, March 2001
! ---------------------------------------------------------------------
#ifdef COUPLED
      use inland_comlsmh
#endif /* COUPLED */
      use inland_com1d
      use inland_lsmmapib
      use inland_ibispar
      use inland_ibisctl
      use inland_comatm
      use inland_combcs
      use inland_comhyd
      use inland_compft
      use inland_comsno
      use inland_comsoi
      use inland_comsum
      use inland_comveg
#ifdef SINGLE_POINT_MODEL
      use inland_comforc ! use everything from comforc.
#endif

      implicit none
!-------------------------------Commons (BATS)--------------------------
#ifndef COUPLED
      integer plon, plat
      plon=nlonsub !plona
      plat=nlatsub !plata
#endif

! Variables in comveg identified on optis' parameter set, was in inland_prealloc
      allocate(clitrl(lbeg:lend),clitrm(lbeg:lend),clitrs(lbeg:lend), &
               clitll(lbeg:lend),clitlm(lbeg:lend),clitls(lbeg:lend), &
               clitwl(lbeg:lend),clitwm(lbeg:lend),clitws(lbeg:lend), &
               csoislon(lbeg:lend),csoislop(lbeg:lend),csoipas(lbeg:lend))
      clitrl(:) = optis_params(1)
      clitrm(:) = optis_params(2)
      clitrs(:) = optis_params(3)
      clitll(:) = optis_params(4)
      clitlm(:) = optis_params(5)
      clitls(:) = optis_params(6)
      clitwl(:) = optis_params(7)
      clitwm(:) = optis_params(8)
      clitws(:) = optis_params(9)
! TODO - what happened to csoislo?
      csoislop(:) = optis_params(10)
      csoislon(:) = optis_params(11)
      csoipas(:) = optis_params(12)

      allocate(wsoi(lbeg:lend,nsoilay))
      wsoi(:,:) = optis_params(13)

! Zero constants in ibiscst part of ibisparm
      stef = 0.
      vonk = 0.
      grav = 0.
      tmelt = 0.
      hfus = 0.
      hvap = 0.
      hsub = 0.
      ch2o = 0.
      cice = 0.
      cair = 0.
      cvap = 0.
      rair = 0.
      rvap = 0.
      cappa = 0.
      rhow = 0.

! Allocate variables in ibiscst part of ibisparm
! Please note, 'mpt' is the equivalent of 'npoi' for a single MPI process.
! FIXME: Decide between mpt or lbeg:lend!
      allocate(vzero(lbeg:lend))

! Zero (non-namelist) constants in ibisctl
      spincons = 0.
      eqyears = 0
      spinfrac = 0.
      nspinsoil = 0
      iyear = 0
      imonth = 0
      iday = 0

#ifdef COUPLED
! Allocate variables in comlsmh
      allocate(h2osnoxy(plonda,beglata:endlata))

      h2osnoxy(:,:) = 0.
#endif /* COUPLED */

! Allocate variables in lsmmapib
!     (begpnt and numpnt allocated separately)
      allocate(ixy(lbeg:lend),jxy(lbeg:lend),lati(lbeg:lend),loni(lbeg:lend), &
               procj(lbeg:lend),procn(lbeg:lend))

      ixy(:) = 0
      jxy(:) = 0
      lati(:) = 0.
      loni(:) = 0.
      procj(:) = 0
      procn(:) = 0

      allocate(ixy1(npoi1),jxy1(npoi1),lati1(npoi1),loni1(npoi1),procj1(npoi1),&
               procn1(npoi1))

      ixy1(:) = 0
      jxy1(:) = 0
      lati1(:) = 0.
      loni1(:) = 0.
      procj1(:) = 0
      procn1(:) = 0

! Allocate variables in com1d
      allocate(terml(lbeg:lend,7),termu(lbeg:lend,7))
      allocate(scalcoefl(lbeg:lend,4),scalcoefu(lbeg:lend,4))
      allocate(firb (lbeg:lend),&
               firg (lbeg:lend),&
               firi (lbeg:lend),&
               firl (lbeg:lend),&
               firs (lbeg:lend),&
               firu (lbeg:lend),&
               fsena (lbeg:lend),&
               fseng (lbeg:lend),&
               fseni(lbeg:lend),&
               fsenl (lbeg:lend),&
               fsens (lbeg:lend),&
               fsenu (lbeg:lend),&
               fvapa (lbeg:lend),&
               fvapg (lbeg:lend),&
               fvapi (lbeg:lend),&
               fvaplt (lbeg:lend),&
               fvaplw (lbeg:lend),&
               fvaps (lbeg:lend),&
               fvaput (lbeg:lend),&
               fvapuw (lbeg:lend),&
               raing(lbeg:lend),&
               rainl(lbeg:lend),&
               rainu(lbeg:lend),&
               snowg(lbeg:lend),&
               snowl(lbeg:lend),&
               snowu(lbeg:lend),&
               soli (lbeg:lend),&
               solg (lbeg:lend),&
               soll (lbeg:lend),&
               sols (lbeg:lend),&
               solu (lbeg:lend),&
               traing(lbeg:lend),&
               trainl(lbeg:lend),&
               trainu(lbeg:lend),&
               tsnowg(lbeg:lend),&
               tsnowl(lbeg:lend),&
               tsnowu(lbeg:lend))
      allocate(nsol(numlv))
      allocate(abupd(lbeg:lend),&
               abupi(lbeg:lend),&
               ablod(lbeg:lend),&
               abloi(lbeg:lend),&
               albsnd(lbeg:lend),&
               albsni(lbeg:lend),&
               albsod(lbeg:lend),&
               albsoi(lbeg:lend),&
               dummy(lbeg:lend),&
               flodd(lbeg:lend),&
               flodi(lbeg:lend),&
               floii(lbeg:lend),&
               fupdd(lbeg:lend),&
               fupdi(lbeg:lend),&
               fupii(lbeg:lend),&
               relod(lbeg:lend),&
               reloi(lbeg:lend),&
               reupd(lbeg:lend),&
               reupi(lbeg:lend),&
               sol2d(lbeg:lend),&
               sol2i(lbeg:lend),&
               sol3d(lbeg:lend),&
               sol3i(lbeg:lend))
      allocate(indsol(numlv,lend-lbeg+1))
      allocate(aloga(lbeg:lend),&
               alogav(lbeg:lend),&
               alogg(lbeg:lend),&
               alogi(lbeg:lend),&
               alogl(lbeg:lend),&
               alogu(lbeg:lend),&
               alog1(lbeg:lend),&
               alog2(lbeg:lend),&
               alog3(lbeg:lend),&
               alog4(lbeg:lend),&
               bdl(lbeg:lend),&
               bdu(lbeg:lend),&
               cl(lbeg:lend),&
               cp(lbeg:lend),&
               cu(lbeg:lend),&
               dil(lbeg:lend),&
               displ(lbeg:lend),&
               dispu(lbeg:lend),&
               diu(lbeg:lend),&
               exphl(lbeg:lend),&
               exphu(lbeg:lend),&
               expl(lbeg:lend),&
               expu(lbeg:lend),&
               pfluxl(lbeg:lend),&
               pfluxs(lbeg:lend),&
               pfluxu(lbeg:lend),&
               rhoa(lbeg:lend),&
               richl(lbeg:lend),&
               richu(lbeg:lend),&
               sg(lbeg:lend),&
               si(lbeg:lend),&
               strahl(lbeg:lend),&
               strahu(lbeg:lend),&
               straml(lbeg:lend),&
               stramu(lbeg:lend),&
               u1(lbeg:lend),&
               u12(lbeg:lend),&
               u2(lbeg:lend),&
               u3(lbeg:lend),&
               u34(lbeg:lend),&
               u4(lbeg:lend),&
               za(lbeg:lend),&
               z1(lbeg:lend),&
               z12(lbeg:lend),&
               z2(lbeg:lend),&
               z3(lbeg:lend),&
               z34(lbeg:lend),&
               z4(lbeg:lend),&
               taux(lbeg:lend),&
               tauy(lbeg:lend),&
               ts2(lbeg:lend),&
               qs2(lbeg:lend),&
               tfaca(lbeg:lend))
      allocate(fwetl (lbeg:lend),&
               fwets (lbeg:lend),&
               fwetu (lbeg:lend),&
               fwetlx (lbeg:lend),&
               fwetsx (lbeg:lend),&
               fwetux (lbeg:lend),&
               rliql (lbeg:lend),&
               rliqs (lbeg:lend),&
               rliqu (lbeg:lend))

      terml(:,:) = 0.
      termu(:,:) = 0.
      scalcoefl(:,:) = 0.
      scalcoefu(:,:) = 0.
      firb(:) = 0.
      firg(:) = 0.
      firi(:) = 0.
      firl(:) = 0.
      firs(:) = 0.
      firu(:) = 0.
      fsena(:) = 0.
      fseng(:) = 0.
      fseni(:) = 0.
      fsenl(:) = 0.
      fsens(:) = 0.
      fsenu(:) = 0.
      fvapa(:) = 0.
      fvapg(:) = 0.
      fvapi(:) = 0.
      fvaplt(:) = 0.
      fvaplw(:) = 0.
      fvaps(:) = 0.
      fvaput(:) = 0.
      fvapuw(:) = 0.
      raing(:) = 0.
      rainl(:) = 0.
      rainu(:) = 0.
      snowg(:) = 0.
      snowl(:) = 0.
      snowu(:) = 0.
      soli(:) = 0.
      solg(:) = 0.
      soll(:) = 0.
      sols(:) = 0.
      solu(:) = 0.
      traing(:) = 0.
      trainl(:) = 0.
      trainu(:) = 0.
      tsnowg(:) = 0.
      tsnowl(:) = 0.
      tsnowu(:) = 0.
      nsol(:) = 0
      abupd(:) = 0.
      abupi(:) = 0.
      ablod(:) = 0.
      abloi(:) = 0.
      albsnd(:) = 0.
      albsni(:) = 0.
      albsod(:) = 0.
      albsoi(:) = 0.
      dummy(:) = 0.
      flodd(:) = 0.
      flodi(:) = 0.
      floii(:) = 0.
      fupdd(:) = 0.
      fupdi(:) = 0.
      fupii(:) = 0.
      relod(:) = 0.
      reloi(:) = 0.
      reupd(:) = 0.
      reupi(:) = 0.
      sol2d(:) = 0.
      sol2i(:) = 0.
      sol3d(:) = 0.
      sol3i(:) = 0.
      indsol(:,:) = 0
      aloga(:) = 0.
      alogav(:) = 0.
      alogg(:) = 0.
      alogi(:) = 0.
      alogl(:) = 0.
      alogu(:) = 0.
      alog1(:) = 0.
      alog2(:) = 0.
      alog3(:) = 0.
      alog4(:) = 0.
      bdl(:) = 0.
      bdu(:) = 0.
      cl(:) = 0.
      cp(:) = 0.
      cu(:) = 0.
      dil(:) = 0.
      displ(:) = 0.
      dispu(:) = 0.
      diu(:) = 0.
      exphl(:) = 0.
      exphu(:) = 0.
      expl(:) = 0.
      expu(:) = 0.
      pfluxl(:) = 0.
      pfluxs(:) = 0.
      pfluxu(:) = 0.
      rhoa(:) = 0.
      richl(:) = 0.
      richu(:) = 0.
      sg(:) = 0.
      si(:) = 0.
      strahl(:) = 0.
      strahu(:) = 0.
      straml(:) = 0.
      stramu(:) = 0.
      u1(:) = 0.
      u12(:) = 0.
      u2(:) = 0.
      u3(:) = 0.
      u34(:) = 0.
      u4(:) = 0.
      za(:) = 0.
      z1(:) = 0.
      z12(:) = 0.
      z2(:) = 0.
      z3(:) = 0.
      z34(:) = 0.
      z4(:) = 0.
      taux(:) = 0.
      tauy(:) = 0.
      ts2(:) = 0.
      qs2(:) = 0.
      tfaca(:) = 0.
      fwetl(:) = 0.
      fwets(:) = 0.
      fwetu(:) = 0.
      fwetlx(:) = 0.
      fwetsx(:) = 0.
      fwetux(:) = 0.
      rliql(:) = 0.
      rliqs(:) = 0.
      rliqu(:) = 0.

! Allocate variables in comveg
      allocate(q12(lbeg:lend),&
               q34(lbeg:lend),&
               sl(lbeg:lend),&
               ss(lbeg:lend),&
               su(lbeg:lend),&
               topparl(lbeg:lend),&
               topparu(lbeg:lend),&
               tl(lbeg:lend),&
               ts(lbeg:lend),&
               tu(lbeg:lend),&
               tlsub(lbeg:lend),&
               t12(lbeg:lend),&
               t34(lbeg:lend),&
               wliql(lbeg:lend),&
               wliqs(lbeg:lend),&
               wliqu(lbeg:lend),&
               wsnol(lbeg:lend),&
               wsnos(lbeg:lend),&
               wsnou(lbeg:lend))

      allocate(agcub(lbeg:lend),&
               agcuc(lbeg:lend),&
               agcls(lbeg:lend),&
               agcl3(lbeg:lend),&
               agcl4(lbeg:lend),&
               ancub(lbeg:lend),&
               ancuc(lbeg:lend),&
               ancls(lbeg:lend),&
               ancl3(lbeg:lend),&
               ancl4(lbeg:lend),&
               totcondub(lbeg:lend),&
               totconduc(lbeg:lend),&
               totcondls(lbeg:lend),&
               totcondl3(lbeg:lend),&
               totcondl4(lbeg:lend))

      allocate(ciub(lbeg:lend),&
               ciuc(lbeg:lend),&
               cils(lbeg:lend),&
               cil3(lbeg:lend),&
               cil4(lbeg:lend),&
               csub(lbeg:lend),&
               csuc(lbeg:lend),&
               csls(lbeg:lend),&
               csl3(lbeg:lend),&
               csl4(lbeg:lend),&
               gsub(lbeg:lend),&
               gsuc(lbeg:lend),&
               gsls(lbeg:lend),&
               gsl3(lbeg:lend),&
               gsl4(lbeg:lend))
 
      allocate(agddl(lbeg:lend),&
               agddu(lbeg:lend),&
               fl(lbeg:lend),&
               fu(lbeg:lend),&
               gdd0(lbeg:lend),&
               gdd0this(lbeg:lend),&
               gdd5(lbeg:lend),&
               gdd5this(lbeg:lend),&
               sapfrac(lbeg:lend),&
               tc(lbeg:lend),&
               tcthis(lbeg:lend),&
               tcmin(lbeg:lend),&
               totlail(lbeg:lend),&
               totlaiu(lbeg:lend),&
               totbiol(lbeg:lend),&
               totbiou(lbeg:lend),&
               tw(lbeg:lend),&
               twthis(lbeg:lend),&
               disturbf(lbeg:lend),&
               disturbo(lbeg:lend),&
               firefac(lbeg:lend),&
               tco2mic(lbeg:lend),&
               tco2root(lbeg:lend),&
               tneetot(lbeg:lend),&
               tnmin(lbeg:lend),&
               tnpptot(lbeg:lend),&
               tgpptot(lbeg:lend),&
               totalit(lbeg:lend),&
               totanlit(lbeg:lend),&
               totcmic(lbeg:lend),&
               totcsoi(lbeg:lend),&
               totfall(lbeg:lend),&
               totlit(lbeg:lend),&
               totnlit(lbeg:lend),&
               totnmic(lbeg:lend),&
               totnsoi(lbeg:lend),&
               totrlit(lbeg:lend),&
               totrnlit(lbeg:lend),&
               cleach(lbeg:lend),&
               tempu(lbeg:lend),&
               templ(lbeg:lend),&
               dropu(lbeg:lend),&
               dropls(lbeg:lend),&
               dropl4(lbeg:lend),&
               dropl3(lbeg:lend),&
               vegtype0(lbeg:lend))

      allocate(cbiol(lbeg:lend,npft),&
               cbior(lbeg:lend,npft),&
               cbiow(lbeg:lend,npft))
 
      allocate(csoislo(lbeg:lend),&
               decompl(lbeg:lend),&
               decomps(lbeg:lend),&
               falll(lbeg:lend),&
               fallr(lbeg:lend),&
               fallw(lbeg:lend),&
               cdisturb(lbeg:lend))

! FIXME: Useless. 0D model runs on only single point, No need to allocate it
!       as a vector but a single variable! Also, this seems to be used on a 
!       single subroutine, so no need to declare on a module at all!
#ifdef SINGLE_POINT_MODEL
      allocate(cbioltot(npoi), cbiortot(npoi), cbiowtot(npoi))
#endif

      allocate(biomass(lbeg:lend,npft),&
               frac(lbeg:lend,npft),&
               plai(lbeg:lend,npft),&
               tnpp(lbeg:lend,npft),&
               tgpp(lbeg:lend,npft))

      allocate(lai(lbeg:lend,2),&
               sai(lbeg:lend,2),&
               zbot(lbeg:lend,2),&
               ztop(lbeg:lend,2),&
               ztopmx(lbeg:lend,2))

      ! dleaf and dstem are allocated on inland_prealloc
      allocate(orieh(2),oriev(2))

      allocate(froot(nsoilay,2))

      allocate(exist(lbeg:lend,npft))

      ! specla, aleaf, awood, aroot are allocated on inland_prealloc

      topparl(:) = 0.
      topparu(:) = 0.
      tl(:) = 0.
      t12(:) = 0.
      t34(:) = 0.

      agcub(:) = 0.
      agcuc(:) = 0.
      agcls(:) = 0.
      agcl3(:) = 0.
      agcl4(:) = 0.
      ancub(:) = 0.
      ancuc(:) = 0.
      ancls(:) = 0.
      ancl3(:) = 0.
      ancl4(:) = 0.
 
      agddl(:) = 0.
      agddu(:) = 0.
      fl(:) = 0.
      fu(:) = 0.
      gdd0(:) = 0.
      gdd5(:) = 0.
      sapfrac(:) = 0.
      tc(:) = 0.
      tcmin(:) = 0.
      totlail(:) = 0.
      totlaiu(:) = 0.
      totbiol(:) = 0.
      totbiou(:) = 0.
      tw(:) = 0.
      disturbf(:) = 0.
      disturbo(:) = 0.
      firefac(:) = 0.
      tco2root(:) = 0.
      tgpptot(:) = 0.
      totnsoi(:) = 0.
      cleach(:) = 0.
      vegtype0(:) = 0.

      cbiol(:,:) = 0.
      cbior(:,:) = 0.
      cbiow(:,:) = 0.
 
      csoislo(:) = 0.
      decompl(:) = 0.
      decomps(:) = 0.
      falll(:) = 0.
      fallr(:) = 0.
      fallw(:) = 0.

      biomass(:,:) = 0.
      frac(:,:) = 0.
      plai(:,:) = 0.
      tnpp(:,:) = 0.
      tgpp(:,:) = 0.

      lai(:,:) = 0.
      sai(:,:) = 0.
      zbot(:,:) = 0.
      ztop(:,:) = 0.
      ztopmx(:,:) = 0.

      orieh(:) = 0.
      oriev(:) = 0.

      froot(:,:) = 0.

      exist(:,:) = 0.

! Allocate variables in comsoi
      allocate(wpud(lbeg:lend),&
               wipud(lbeg:lend),&
               z0soi(lbeg:lend),&
               albsav(lbeg:lend),&
               albsan(lbeg:lend),&
               stresstl(lbeg:lend),&
               stresstu(lbeg:lend),&
               heati(lbeg:lend),&
               heatg(lbeg:lend),&
               hvasug(lbeg:lend),&
               hvasui(lbeg:lend),&
               soihfl(lbeg:lend),&
               tg(lbeg:lend),&
               ti(lbeg:lend))

! hsoi allocation moved to inland_prealloc.

      allocate(tsoi(lbeg:lend,nsoilay),&
               wisoi(lbeg:lend,nsoilay),&
               consoi(lbeg:lend,nsoilay),&
               csoi(lbeg:lend,nsoilay),&
               hydraul(lbeg:lend,nsoilay),&
               suction(lbeg:lend,nsoilay),&
               bex(lbeg:lend,nsoilay),&
               sfield(lbeg:lend,nsoilay),&
               swilt(lbeg:lend,nsoilay),&
               rhosoi(lbeg:lend,nsoilay),&
               poros(lbeg:lend,nsoilay),&
               porosflo(lbeg:lend,nsoilay),&
               stressl(lbeg:lend,nsoilay),&
               stressu(lbeg:lend,nsoilay),&
               upsoiu(lbeg:lend,nsoilay),&
               upsoil(lbeg:lend,nsoilay))

      allocate(hflo(lbeg:lend,nsoilay+1))

      allocate(ibex(lbeg:lend,nsoilay))

      allocate(qglif(lbeg:lend,4))

      heati(:) = 0.
      heatg(:) = 0.
      hvasug(:) = 0.
      hvasui(:) = 0.
      soihfl(:) = 0.
      tg(:) = 0.

      tsoi(:,:) = 0.
      wisoi(:,:) = 0.
      consoi(:,:) = 0.
      porosflo(:,:) = 0.
      upsoiu(:,:) = 0.
      upsoil(:,:) = 0.

      hflo(:,:) = 0.

      qglif(:,:) = 0.

! Allocate variables in comsno
      allocate(fi(lbeg:lend),&
               tsno(lbeg:lend,nsnolay),&
               hsno(lbeg:lend,nsnolay))

      fi(:) = 0.
      tsno(:,:) = 0.
      hsno(:,:) = 0.

! Allocate variables in comatm
      allocate(coszen(lbeg:lend),&
               fira(lbeg:lend),&
               solad(lbeg:lend,nband),&
               solai(lbeg:lend,nband),&
               asurd(lbeg:lend,nband),&
               asuri(lbeg:lend,nband),&
               ua(lbeg:lend),&
               ux(lbeg:lend),&
               uy(lbeg:lend),&
               ta(lbeg:lend),&
               qa(lbeg:lend),&
               raina(lbeg:lend),&
               snowa(lbeg:lend),&
               psurf(lbeg:lend),&
               tmax(lbeg:lend),&
               tmin(lbeg:lend),&
               qd(lbeg:lend),&
               ud(lbeg:lend))

      coszen(:) = 0.
      fira(:) = 0.
      solad(:,:) = 0.
      solai(:,:) = 0.
      ua(:) = 0.
      ux(:) = 0.
      uy(:) = 0.
      ta(:) = 0.
      qa(:) = 0.
      raina(:) = 0.
      snowa(:) = 0.
      psurf(:) = 0.
      tmax(:) = 0.
      tmin(:) = 0.
      qd(:) = 0.
      ud(:) = 0.

! comatm's weather generator specific variables
!---------------------------------------------------
!   There's no need to initialize these variables. This is done in the 
! subroutine in a adequate frequency.
      allocate(precip(lbeg:lend),precipdaysum(lbeg:lend),iwet(lbeg:lend), &
               iwetdaysum(lbeg:lend),cloud(lbeg:lend))
      allocate(precipday(lbeg:lend,31),iwetday(lbeg:lend,31), &
               xstore(lbeg:lend,3))
      allocate(rh(lbeg:lend)) ! this variable is used only on diurnal subroutine
      xstore(:,:) = 0. !xstore needs to be initialized

! Allocate variables in comhyd
      allocate(ginvap(lbeg:lend),gsuvap(lbeg:lend),gtrans(lbeg:lend),&
               gtransu(lbeg:lend),gtransl(lbeg:lend),grunof(lbeg:lend),&
               gdrain(lbeg:lend),gadjust(lbeg:lend))

      gtransu(:) = 0.
      gtransl(:) = 0.
      gadjust(:) = 0.

! combcs's weather generator specific variables
!-----------------------------------------------
! FIXME: MUST DECIDE::: in place of npoi, either lbeg:lend or mpt!!!
!   *** For CCSM3 convention, using lbeg:lend as the remaining variables at
!       combcs are using this label. This can yet impose problems to the model.
! Some 'missing' variables are used on readit thus allocated on inland_prealloc.
! Variables initialized on inland_prealloc will be associated to values on
! readit. Will these need to be zeroed?
      allocate(xinprecd(lbeg:lend),xintd(lbeg:lend),xintrngd(lbeg:lend), &
               xincldd(lbeg:lend),xinqd(lbeg:lend),xinwindd(lbeg:lend),&
               xintmaxd(lbeg:lend), xintmind(lbeg:lend))

! Allocate variables in comsum
      allocate(ndtime(numlv),nmtime(numlv),nytime(numlv))

      allocate(anytime(lbeg:lend))

      allocate(dwtot(lbeg:lend),wtotp(lbeg:lend),wtot(lbeg:lend))

      allocate(td(lbeg:lend),&
               adrain(lbeg:lend),&
               adsnow(lbeg:lend),&
               adaet(lbeg:lend),&
               adtrunoff(lbeg:lend),&
               adsrunoff(lbeg:lend),&
               addrainage(lbeg:lend),&
               adsnod(lbeg:lend),&
               adsnof(lbeg:lend),&
               adwsoi(lbeg:lend),&
               adwisoi(lbeg:lend),&
               adtsoi(lbeg:lend),&
               adwsoic(lbeg:lend),&
               adtsoic(lbeg:lend),&
               adco2mic(lbeg:lend),&
               adco2root(lbeg:lend),&
               adco2soi(lbeg:lend),&
               adco2ratio(lbeg:lend),&
               adnmintot(lbeg:lend),&
               adtlaysoi(lbeg:lend),&
               adwlaysoi(lbeg:lend),&
               adneetot(lbeg:lend),&
               adtnpptot(lbeg:lend))

      allocate(amts2(lbeg:lend),&
               amrain(lbeg:lend),&
               amsnow(lbeg:lend),&
               amqa(lbeg:lend),&
               amaet(lbeg:lend),&
               amtransu(lbeg:lend),&
               amtransl(lbeg:lend),&
               amsuvap(lbeg:lend),&
               aminvap(lbeg:lend),&
               amtrunoff(lbeg:lend),&
               amsrunoff(lbeg:lend),&
               amdrainage(lbeg:lend),&
               amwsoi(lbeg:lend),&
               amwisoi(lbeg:lend),&
               amvwc(lbeg:lend),&
               amawc(lbeg:lend),&
               amtsoi(lbeg:lend),&
               amsnod(lbeg:lend),&
               amsnof(lbeg:lend),&
               amlaiu(lbeg:lend),&
               amlail(lbeg:lend),&
               amsolar(lbeg:lend),&
               amreflect(lbeg:lend),&
               amirdown(lbeg:lend),&
               amirup(lbeg:lend),&
               amsens(lbeg:lend),&
               amlatent(lbeg:lend),&
               amnpptot(lbeg:lend),&
               amneetot(lbeg:lend),&
               amco2mic(lbeg:lend),&
               amco2root(lbeg:lend),&
               amco2soi(lbeg:lend),&
               amco2ratio(lbeg:lend),&
               amnmintot(lbeg:lend))

      allocate(amnpp(lbeg:lend,npft))

      allocate(ayprcp(lbeg:lend),&
               ayaet(lbeg:lend),&
               aytrans(lbeg:lend),&
               aytrunoff(lbeg:lend),&
               aysrunoff(lbeg:lend),&
               aydrainage(lbeg:lend),&
               aywsoi(lbeg:lend),&
               aywisoi(lbeg:lend),&
               ayvwc(lbeg:lend),&
               ayawc(lbeg:lend),&
               aytsoi(lbeg:lend),&
               ayrratio(lbeg:lend),&
               aytratio(lbeg:lend),&
               aysolar(lbeg:lend),&
               ayreflect(lbeg:lend),&
               ayirdown(lbeg:lend),&
               ayirup(lbeg:lend),&
               aysens(lbeg:lend),&
               aylatent(lbeg:lend),&
               aystresstu(lbeg:lend),&
               aystresstl(lbeg:lend),&
               ayanpptot(lbeg:lend),&
               aynpptot(lbeg:lend),&
               aygpptot(lbeg:lend),&
               ayalit(lbeg:lend),&
               ayblit(lbeg:lend),&
               aycsoi(lbeg:lend),&
               aycmic(lbeg:lend),&
               ayanlit(lbeg:lend),&
               aybnlit(lbeg:lend),&
               aynsoi(lbeg:lend),&
               ayneetot(lbeg:lend),&
               ayco2mic(lbeg:lend),&
               ayco2root(lbeg:lend),&
               ayco2soi(lbeg:lend),&
               aynmintot(lbeg:lend),&
               ayrootbio(lbeg:lend),&
               caccount(lbeg:lend))

      allocate(ayanpp(lbeg:lend,npft),&
               aynpp(lbeg:lend,npft),&
               aygpp(lbeg:lend,npft))

      allocate(a10td(lbeg:lend),&
               a10ancub(lbeg:lend),&
               a10ancuc(lbeg:lend),&
               a10ancls(lbeg:lend),&
               a10ancl3(lbeg:lend),&
               a10ancl4(lbeg:lend),&
               a10scalparamu(lbeg:lend),&
               a10scalparaml(lbeg:lend),&
               a10daylightu(lbeg:lend),&
               a10daylightl(lbeg:lend))

      allocate(storedn(lbeg:lend),&
               yrleach(lbeg:lend),&
               ynleach(lbeg:lend))

      ndtime(:) = 0
      nmtime(:) = 0
      nytime(:) = 0

      anytime(:) = 0.

! moved to ibisparm allocation area on this file
!     garea(:) = 0.

      dwtot(:) = 0. 
      wtotp(:) = 0. 
      wtot(:) = 0.

      adtsoic(:) = 0.
      adco2ratio(:) = 0.
      adneetot(:) = 0.
      adtnpptot(:) = 0.

      amts2(:) = 0.
      amnpptot(:) = 0.
      amneetot(:) = 0.
      amco2soi(:) = 0.
      amco2ratio(:) = 0.

      ayprcp(:) = 0.
      ayaet(:) = 0.
      aytrans(:) = 0.
      aytrunoff(:) = 0.
      aysrunoff(:) = 0.
      aydrainage(:) = 0.
      aywsoi(:) = 0.
      aywisoi(:) = 0.
      ayvwc(:) = 0.
      ayawc(:) = 0.
      aytsoi(:) = 0.
      ayrratio(:) = 0.
      aytratio(:) = 0.
      aysolar(:) = 0.
      ayreflect(:) = 0.
      ayirdown(:) = 0.
      ayirup(:) = 0.
      aysens(:) = 0.
      aylatent(:) = 0.
      aystresstu(:) = 0.
      aystresstl(:) = 0.
      ayanpptot(:) = 0.
      aynpptot(:) = 0.
      aygpptot(:) = 0.
      ayalit(:) = 0.
      ayblit(:) = 0.
      aycsoi(:) = 0.
      aycmic(:) = 0.
      ayanlit(:) = 0.
      aybnlit(:) = 0.
      aynsoi(:) = 0.
      ayneetot(:) = 0.
      ayco2mic(:) = 0.
      ayco2root(:) = 0.
      ayco2soi(:) = 0.
      aynmintot(:) = 0.
      ayrootbio(:) = 0.
      caccount(:) = 0.

      ayanpp(:,:) = 0.
      aynpp(:,:) = 0.
      aygpp(:,:) = 0.

      a10td(:) = 0.
      a10ancub(:) = 0.
      a10ancuc(:) = 0.
      a10ancls(:) = 0.
      a10ancl3(:) = 0.
      a10ancl4(:) = 0.
      a10scalparamu(:) = 0.
      a10scalparaml(:) = 0.
      a10daylightu(:) = 0.
      a10daylightl(:) = 0.

      storedn(:) = 0.
      yrleach(:) = 0.
      ynleach(:) = 0.

! All comtex module variables is allocated on inland_prealloc!

! Allocate variables in compft
!   vmax_pft, tauleaf, tauroot, tauwood0, TminL, TminU, Twarm, GDD, plai_init
! are all allocated on inland_prealloc
      allocate(tauwood(npft))
      tauwood(:) = 0.

#ifdef SINGLE_POINT_MODEL

! Allocate variables in comforc (forcings for the single point model)
      allocate(xta(npoi,dimforc),xprec(npoi,dimforc),xua(npoi,dimforc),  &
               xcld(npoi,dimforc),xqa(npoi,dimforc),                     &
               xsmoi(npoi,nsoilay,dimforc),xstemp(npoi,nsoilay,dimforc), &
               xsin(npoi,dimforc),xlin(npoi,dimforc),xlati(npoi))

! TODO: zero only variables that need to be zeroed. - fzm
      xta(:,:) = 0.
      xprec(:,:) = 0.
      xua(:,:) = 0.
      xcld(:,:) = 0.
      xqa(:,:) = 0.
      xsmoi(:,:,:) = 0.
      xstemp(:,:,:) = 0.
      xsin(:,:) = 0.
      xlin(:,:) = 0.
      xlati(:) = 0.
#endif /* SINGLE_POINT_MODEL */

      return
end subroutine ibisalloc
