#include "inland_config.h"
module inland_ibisctl
      implicit none
      public
      save

!
! Model control variables
!
      integer iyearout  ! 0: no yearly output 1: yearly output
      integer imonthout ! 0: no monthly output 1: monthly output
      integer idailyout   ! 0: no daily output 1: daily output
      integer ipointout ! 0: no point output
                        ! 1: point output
      integer isimveg   ! 0: static veg 
!                       ! 1: dynam veg initialized w/ fixed
!                       ! 2: dynam veg initialized w/ cold start
      integer isimfire  ! 0: fixed fire  1: dynamic fire
      integer isimco2   ! 0: fixed co2   1: changing co2
      integer ccmexist  ! 0: calculates existence arrays using climatological temperatures
!                       ! 1: calculates existence arrays using modeled monthly temperatures 
!
      integer soicspin  ! 0: no spinup procedure for soil carbon
!                       ! 1: acceleration procedure used
!
!
      integer spinmax   ! degree of soil carbon acceleration
!
      real*8 spincons   ! number of times soilbgc subroutine is
!                       ! called for each day in simulation during
!                       ! acceleration procedure
      integer eqyears   ! years used past spin up to slowly bring
!                       ! entire soil to a steady equilibrium
      real*8 spinfrac   ! fraction of nspinsoil time used to
!                       ! spin up soil at maximum spin up rate
!
      integer nspinsoil ! year of simulation that soil c reaches equilibrium
!
      integer istep,  & ! timestep counter (per day)
              iyear0, & ! 1st year of simulation
              imonth0,& ! 1st month of simulation
              iday0,  & ! 1st day of simulation
              iyear,  & ! current year of simulation
              imonth, & ! current month of simulation
              iday,   & ! current day of simulation
              jday      ! julian day of the simulation

#ifdef SINGLE_POINT_MODEL
      real nan          ! not a number representation (used on 0D)
      parameter(nan=-999.99)
#endif /* SINGLE_POINT_MODEL */
!
end module inland_ibisctl
