#include "inland_config.h"
! Inland's Pre allocate phase subroutine

!   This subroutine Allocates variables as they are needed by rd_param
! and readit subroutines.
subroutine inland_prealloc
      use inland_ibisparm, only: npft,nband,nsoilay,ndat,plona,plata,nlonsub, &
                                 nlatsub
      use inland_compft, only: vmax_pft,tauleaf,tauroot,tauwood0,TminL,TminU, &
                               Twarm,GDD
      use inland_comveg, only: specla,aleaf,aroot,awood,rhoveg,tauveg,dleaf,  &
                               dstem, clitrl, clitrm, clitrs, clitll, clitlm, &
                               clitls, clitwl, clitwm, clitws, csoislon,      &
                               csoislop, csoipas, fu, fl
      use inland_comtex ! only: all!
      use inland_combgc, only: cnr
      use inland_comsoi, only: hsoi, sand, clay, wsoi
      use inland_comwork ! only: all!
      use inland_combcs, only: xintopo,xinveg,deltat,xint,clmwet, &
                               clmtrng,clmt,clmprec,clmcld,clmq,clmwind, &
                               xintrng,xinprec,xincld,xinq,xinwet,xinwetmon, &
                               xinprecmon, xintrngmon, xincldmon, xinqmon, &
                               xinwindmon, xintmon,obswet,obstrng,obst,obsprec, &
                               obscld, obsq, obswind,xinwind

      implicit none

!! Variables for rd_param
!==========================
! From compft
      allocate(vmax_pft(npft),tauleaf(npft),tauroot(npft),tauwood0(npft), &
               TminL(npft),TminU(npft),Twarm(npft),GDD(npft))

      vmax_pft(:) = 0.
      tauleaf(:) = 0.
      tauroot(:) = 0.
      tauwood0(:) = 0.
      TminL(:) = 0.
      TminU(:) = 0.
      Twarm(:) = 0.
      GDD(:) = 0.

! From comveg
      allocate(specla(npft),aleaf(npft),aroot(npft),awood(npft), &
               rhoveg(nband,2),tauveg(nband,2))
      allocate(dleaf(2),dstem(2))
      specla(:) = 0.
      aleaf(:)  = 0.
      aroot(:)  = 0.
      awood(:)  = 0.
      rhoveg(:,:) = 0.
      tauveg(:,:) = 0.
      dleaf(:) = 0.
      dstem(:) = 0.

! Allocate variables in comsoi
      allocate(hsoi(nsoilay+1))! FIXME: really needed to allocate nsoilay+1?
      hsoi(:) = 0.

! Allocate variables in comtex
      allocate(texdat(3,ndat),porosdat(ndat),sfielddat(ndat),swiltdat(ndat), &
               bexdat(ndat),suctiondat(ndat),hydrauldat(ndat))
      texdat(:,:) = 0.     
      porosdat(:) = 0.
      sfielddat(:) = 0.
      swiltdat(:) = 0.
      bexdat(:) = 0.
      suctiondat(:) = 0.
      hydrauldat(:) = 0.

! Allocate variables in combgc
      allocate(cnr(10))
      cnr(:) = 0.

!! Variables for readit
!================================
! Allocate variables in comwork
!--------------------------------
! Get comwork's ndim4 size
!    The base values are now on ibisparm module; in the future they will be read
! from the inland.infile called right before inland_prealloc.
      ndim4 = max(nlon,nlat,nband,nsoilay,nsnolay,npft)

!    Now ndim3 is calculated with actual max value (no longer manually chosen),
! taking advantage of dynamic allocation of vectors.
      ndim3=nlon*nlat*max(nband,nsoilay,nsnolay,npft)
      allocate(lonscale(nlon),latscale(nlat))
      allocate(work(ndim2),cdummy(ndim3))
      lonscale(:) = 0.
      latscale(:) = 0.
      work(:) = 0.
      cdummy(:) = 0.

! removed allocation of variables with npoi dimension, now in readit

end subroutine inland_prealloc
