#include "inland_config.h"
#ifdef PCMIBIS
#endif
! ---------------------------------------------------------------------
subroutine vec2arr(vect, array)
! ---------------------------------------------------------------------
      use inland_ibispar
      use inland_comwork, only: ocean, lonindex, latindex
#ifdef COUPLED
      use inland_intermap
#endif /* COUPLED */

      implicit none
!------------------------------Arguments--------------------------------
! puts vector of land-only points back into array
      real*8, intent(out) :: array(plona,plata)
      real*8, intent(in)  :: vect(lbeg:lend)

#ifdef COUPLED
      real*8 arlocal(plona,beglata:endlata)

      arlocal(:,:) = ocean
      call ibis_to_ccm(arlocal, vect, plona, beglata, endlata, 1)
      call gathvar(array, arlocal, plona)
#else /* COUPLED */
      integer i

      array(:,:)=ocean
      do 10 i=lbeg,lend
         array(lonindex(i),latindex(i)) = vect(i)
10    continue
#endif
      return
end subroutine vec2arr
